unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
     asm
       MOV AX,0h  {0 hex start of CMOS memory address}

@L1:   OUT 70h,AX {Goto address of CMOS memory specified by the contents of Accumulator}
       MOV BX,AX  {Save contents of Accumulator (OUT instruction can only use Accumulator)}
       MOV AX,0h  {Put 0 hex data into CMOS memory}
       OUT 71h,AX {Put 0 hex data into CMOS memory}
       MOV AX,BX  {Restore contents of Accumulator}
       INC AX     {Add 1 to contents of the Accumulator}
       CMP AX,03Fh{Remmember 3F hex equals 63 Dec Have we put 0 hex in CMOS memory addreses from 0 Dec to 63 DEC ?}
       JNZ @L1    {Has the L1 loop run 64 times?}
     end;
ShowMessage('Cleared all CMOS that can be cleared');
end;

end.
